Public Member Functions | Data Fields

# AIListWindow Struct Reference

Window that let you choose an available AI. More...

Inheritance diagram for AIListWindow:

## Public Member Functions
| AIListWindow (WindowDesc *desc, CompanyID slot)
| Constructor for the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | ChangeAI ()
| Changes the AI of the current slot.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Data Fields
const ScriptInfoList * | info_list
| The list of Scripts.
int | selected
| The currently selected Script.
CompanyID | slot
| The company we're selecting a new Script for.
int | line_height
| Height of a row in the matrix widget.
Scrollbar * | vscroll
| Cache of the vertical scrollbar.

## Detailed Description

Window that let you choose an available AI.

Definition at line 57 of file ai_gui.cpp.

## Constructor & Destructor Documentation

AIListWindow::AIListWindow | ( | WindowDesc * | desc,
|  | CompanyID | slot |
| ) |  |  | `[inline]`

Constructor for the window.

Parameters:

  | desc | The description of the window.
  | slot | The company we're changing the AI for.

Definition at line 69 of file ai_gui.cpp.

References Window::CreateNestedTree(), Window::FinishInitNested(), ScriptConfig::GetInfo(), Window::GetScrollbar(), AI::GetUniqueInfoList(), Game::GetUniqueInfoList(), ScriptConfig::HasScript(), info_list, OWNER_DEITY, selected, Scrollbar::SetCount(), vscroll, and WID_AIL_SCROLLBAR.

## Member Function Documentation

virtual void AIListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 118 of file ai_gui.cpp.

References DrawString(), DrawStringMultiLine(), FONT_HEIGHT_NORMAL, ScriptInfo::GetAuthor(), ScriptInfo::GetDescription(), ScriptInfo::GetURL(), ScriptInfo::GetVersion(), info_list, Scrollbar::IsVisible(), line_height, OWNER_DEITY, selected, SetDParam(), SetDParamStr(), vscroll, WD_FRAMERECT_BOTTOM, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, WD_MATRIX_LEFT, WD_MATRIX_RIGHT, WD_MATRIX_TOP, WID_AIL_INFO_BG, and WID_AIL_LIST.

virtual void AIListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 183 of file ai_gui.cpp.

References ChangeAI(), Scrollbar::GetScrolledRowFromWidget(), info_list, selected, Window::SetDirty(), vscroll, WID_AIL_ACCEPT, WID_AIL_CANCEL, and WID_AIL_LIST.

virtual void AIListWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 221 of file ai_gui.cpp.

References Scrollbar::GetCount(), info_list, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), min(), selected, Scrollbar::SetCount(), and vscroll.

virtual void AIListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 211 of file ai_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), vscroll, and WID_AIL_LIST.

virtual void AIListWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 98 of file ai_gui.cpp.

References OWNER_DEITY, SetDParam(), and WID_AIL_CAPTION.

virtual void AIListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 107 of file ai_gui.cpp.

References FONT_HEIGHT_NORMAL, line_height, WD_MATRIX_TOP, and WID_AIL_LIST.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp